/* Generated by ts-generator ver. 0.0.8 */
/* tslint:disable */

import { Contract, ContractTransaction, EventFilter, Signer } from "ethers";
import { Listener, Provider } from "ethers/providers";
import { Arrayish, BigNumber, BigNumberish, Interface } from "ethers/utils";
import {
  TransactionOverrides,
  TypedEventDescription,
  TypedFunctionDescription
} from ".";

interface IssuerInterface extends Interface {
  functions: {
    certificateTopic: TypedFunctionDescription<{ encode([]: []): string }>;

    isOwner: TypedFunctionDescription<{ encode([]: []): string }>;

    owner: TypedFunctionDescription<{ encode([]: []): string }>;

    registry: TypedFunctionDescription<{ encode([]: []): string }>;

    renounceOwnership: TypedFunctionDescription<{ encode([]: []): string }>;

    transferOwnership: TypedFunctionDescription<{
      encode([newOwner]: [string]): string;
    }>;

    initialize: TypedFunctionDescription<{
      encode([_certificateTopic, _registry, _owner]: [
        BigNumberish,
        string,
        string
      ]): string;
    }>;

    getCertificationRequest: TypedFunctionDescription<{
      encode([_requestId]: [BigNumberish]): string;
    }>;

    getCertificateCommitment: TypedFunctionDescription<{
      encode([certificateId]: [BigNumberish]): string;
    }>;

    totalRequests: TypedFunctionDescription<{ encode([]: []): string }>;

    requestCertificationFor: TypedFunctionDescription<{
      encode([_data, _owner, _private]: [Arrayish, string, boolean]): string;
    }>;

    requestCertification: TypedFunctionDescription<{
      encode([_data, _private]: [Arrayish, boolean]): string;
    }>;

    isRequestValid: TypedFunctionDescription<{
      encode([_requestId]: [BigNumberish]): string;
    }>;

    revokeRequest: TypedFunctionDescription<{
      encode([_requestId]: [BigNumberish]): string;
    }>;

    revokeCertificate: TypedFunctionDescription<{
      encode([_certificateId]: [BigNumberish]): string;
    }>;

    approveCertificationRequest: TypedFunctionDescription<{
      encode([_requestId, _value, _validityData]: [
        BigNumberish,
        BigNumberish,
        Arrayish
      ]): string;
    }>;

    issue: TypedFunctionDescription<{
      encode([_to, _value, _data]: [string, BigNumberish, Arrayish]): string;
    }>;

    approveCertificationRequestPrivate: TypedFunctionDescription<{
      encode([_requestId, _commitment, _validityData]: [
        BigNumberish,
        Arrayish,
        Arrayish
      ]): string;
    }>;

    issuePrivate: TypedFunctionDescription<{
      encode([_to, _commitment, _data]: [string, Arrayish, Arrayish]): string;
    }>;

    requestPrivateTransfer: TypedFunctionDescription<{
      encode([_certificateId, _ownerAddressLeafHash]: [
        BigNumberish,
        Arrayish
      ]): string;
    }>;

    approvePrivateTransfer: TypedFunctionDescription<{
      encode([_certificateId, _proof, _previousCommitment, _commitment]: [
        BigNumberish,
        { left: boolean; hash: Arrayish }[],
        Arrayish,
        Arrayish
      ]): string;
    }>;

    requestMigrateToPublic: TypedFunctionDescription<{
      encode([_certificateId, _ownerAddressLeafHash]: [
        BigNumberish,
        Arrayish
      ]): string;
    }>;

    getPrivateTransferRequest: TypedFunctionDescription<{
      encode([_certificateId]: [BigNumberish]): string;
    }>;

    getMigrationRequest: TypedFunctionDescription<{
      encode([_requestId]: [BigNumberish]): string;
    }>;

    getMigrationRequestId: TypedFunctionDescription<{
      encode([_certificateId]: [BigNumberish]): string;
    }>;

    migrateToPublic: TypedFunctionDescription<{
      encode([_requestId, _volume, _salt, _proof]: [
        BigNumberish,
        BigNumberish,
        string,
        { left: boolean; hash: Arrayish }[]
      ]): string;
    }>;

    encodeData: TypedFunctionDescription<{
      encode([_from, _to, _deviceId]: [
        BigNumberish,
        BigNumberish,
        string
      ]): string;
    }>;

    decodeData: TypedFunctionDescription<{
      encode([_data]: [Arrayish]): string;
    }>;

    getRegistryAddress: TypedFunctionDescription<{ encode([]: []): string }>;

    version: TypedFunctionDescription<{ encode([]: []): string }>;
  };

  events: {
    CertificateMigratedToPublic: TypedEventDescription<{
      encodeTopics([_certificateId, _owner, _amount]: [
        BigNumberish | null,
        string | null,
        BigNumberish | null
      ]): string[];
    }>;

    CertificateRevoked: TypedEventDescription<{
      encodeTopics([_certificateId]: [BigNumberish | null]): string[];
    }>;

    CertificationRequestApproved: TypedEventDescription<{
      encodeTopics([_owner, _id, _certificateId]: [
        string | null,
        BigNumberish | null,
        BigNumberish | null
      ]): string[];
    }>;

    CertificationRequestRevoked: TypedEventDescription<{
      encodeTopics([_owner, _id]: [
        string | null,
        BigNumberish | null
      ]): string[];
    }>;

    CertificationRequested: TypedEventDescription<{
      encodeTopics([_owner, _id, _deviceId]: [
        string | null,
        BigNumberish | null,
        string | null
      ]): string[];
    }>;

    CommitmentUpdated: TypedEventDescription<{
      encodeTopics([_owner, _id, _commitment]: [
        string | null,
        BigNumberish | null,
        null
      ]): string[];
    }>;

    MigrateToPublicRequested: TypedEventDescription<{
      encodeTopics([_owner, _id]: [
        string | null,
        BigNumberish | null
      ]): string[];
    }>;

    OwnershipTransferred: TypedEventDescription<{
      encodeTopics([previousOwner, newOwner]: [
        string | null,
        string | null
      ]): string[];
    }>;

    PrivateTransferRequested: TypedEventDescription<{
      encodeTopics([_owner, _certificateId]: [
        string | null,
        BigNumberish | null
      ]): string[];
    }>;
  };
}

export class Issuer extends Contract {
  connect(signerOrProvider: Signer | Provider | string): Issuer;
  attach(addressOrName: string): Issuer;
  deployed(): Promise<Issuer>;

  on(event: EventFilter | string, listener: Listener): Issuer;
  once(event: EventFilter | string, listener: Listener): Issuer;
  addListener(eventName: EventFilter | string, listener: Listener): Issuer;
  removeAllListeners(eventName: EventFilter | string): Issuer;
  removeListener(eventName: any, listener: Listener): Issuer;

  interface: IssuerInterface;

  functions: {
    certificateTopic(): Promise<BigNumber>;

    isOwner(): Promise<boolean>;

    owner(): Promise<string>;

    registry(): Promise<string>;

    renounceOwnership(
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    transferOwnership(
      newOwner: string,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    initialize(
      _certificateTopic: BigNumberish,
      _registry: string,
      _owner: string,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    getCertificationRequest(
      _requestId: BigNumberish
    ): Promise<{
      owner: string;
      data: string;
      approved: boolean;
      revoked: boolean;
      isPrivate: boolean;
    }>;

    getCertificateCommitment(certificateId: BigNumberish): Promise<string>;

    totalRequests(): Promise<BigNumber>;

    requestCertificationFor(
      _data: Arrayish,
      _owner: string,
      _private: boolean,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    requestCertification(
      _data: Arrayish,
      _private: boolean,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    isRequestValid(_requestId: BigNumberish): Promise<boolean>;

    revokeRequest(
      _requestId: BigNumberish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    revokeCertificate(
      _certificateId: BigNumberish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    approveCertificationRequest(
      _requestId: BigNumberish,
      _value: BigNumberish,
      _validityData: Arrayish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    issue(
      _to: string,
      _value: BigNumberish,
      _data: Arrayish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    approveCertificationRequestPrivate(
      _requestId: BigNumberish,
      _commitment: Arrayish,
      _validityData: Arrayish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    issuePrivate(
      _to: string,
      _commitment: Arrayish,
      _data: Arrayish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    requestPrivateTransfer(
      _certificateId: BigNumberish,
      _ownerAddressLeafHash: Arrayish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    approvePrivateTransfer(
      _certificateId: BigNumberish,
      _proof: { left: boolean; hash: Arrayish }[],
      _previousCommitment: Arrayish,
      _commitment: Arrayish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    requestMigrateToPublic(
      _certificateId: BigNumberish,
      _ownerAddressLeafHash: Arrayish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    getPrivateTransferRequest(
      _certificateId: BigNumberish
    ): Promise<{ owner: string; hash: string }>;

    getMigrationRequest(
      _requestId: BigNumberish
    ): Promise<{
      owner: string;
      certificateId: BigNumber;
      hash: string;
      approved: boolean;
    }>;

    getMigrationRequestId(_certificateId: BigNumberish): Promise<BigNumber>;

    migrateToPublic(
      _requestId: BigNumberish,
      _volume: BigNumberish,
      _salt: string,
      _proof: { left: boolean; hash: Arrayish }[],
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    encodeData(
      _from: BigNumberish,
      _to: BigNumberish,
      _deviceId: string
    ): Promise<string>;

    decodeData(
      _data: Arrayish
    ): Promise<{
      0: BigNumber;
      1: BigNumber;
      2: string;
    }>;

    getRegistryAddress(): Promise<string>;

    version(): Promise<string>;
  };

  certificateTopic(): Promise<BigNumber>;

  isOwner(): Promise<boolean>;

  owner(): Promise<string>;

  registry(): Promise<string>;

  renounceOwnership(
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  transferOwnership(
    newOwner: string,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  initialize(
    _certificateTopic: BigNumberish,
    _registry: string,
    _owner: string,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  getCertificationRequest(
    _requestId: BigNumberish
  ): Promise<{
    owner: string;
    data: string;
    approved: boolean;
    revoked: boolean;
    isPrivate: boolean;
  }>;

  getCertificateCommitment(certificateId: BigNumberish): Promise<string>;

  totalRequests(): Promise<BigNumber>;

  requestCertificationFor(
    _data: Arrayish,
    _owner: string,
    _private: boolean,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  requestCertification(
    _data: Arrayish,
    _private: boolean,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  isRequestValid(_requestId: BigNumberish): Promise<boolean>;

  revokeRequest(
    _requestId: BigNumberish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  revokeCertificate(
    _certificateId: BigNumberish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  approveCertificationRequest(
    _requestId: BigNumberish,
    _value: BigNumberish,
    _validityData: Arrayish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  issue(
    _to: string,
    _value: BigNumberish,
    _data: Arrayish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  approveCertificationRequestPrivate(
    _requestId: BigNumberish,
    _commitment: Arrayish,
    _validityData: Arrayish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  issuePrivate(
    _to: string,
    _commitment: Arrayish,
    _data: Arrayish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  requestPrivateTransfer(
    _certificateId: BigNumberish,
    _ownerAddressLeafHash: Arrayish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  approvePrivateTransfer(
    _certificateId: BigNumberish,
    _proof: { left: boolean; hash: Arrayish }[],
    _previousCommitment: Arrayish,
    _commitment: Arrayish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  requestMigrateToPublic(
    _certificateId: BigNumberish,
    _ownerAddressLeafHash: Arrayish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  getPrivateTransferRequest(
    _certificateId: BigNumberish
  ): Promise<{ owner: string; hash: string }>;

  getMigrationRequest(
    _requestId: BigNumberish
  ): Promise<{
    owner: string;
    certificateId: BigNumber;
    hash: string;
    approved: boolean;
  }>;

  getMigrationRequestId(_certificateId: BigNumberish): Promise<BigNumber>;

  migrateToPublic(
    _requestId: BigNumberish,
    _volume: BigNumberish,
    _salt: string,
    _proof: { left: boolean; hash: Arrayish }[],
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  encodeData(
    _from: BigNumberish,
    _to: BigNumberish,
    _deviceId: string
  ): Promise<string>;

  decodeData(
    _data: Arrayish
  ): Promise<{
    0: BigNumber;
    1: BigNumber;
    2: string;
  }>;

  getRegistryAddress(): Promise<string>;

  version(): Promise<string>;

  filters: {
    CertificateMigratedToPublic(
      _certificateId: BigNumberish | null,
      _owner: string | null,
      _amount: BigNumberish | null
    ): EventFilter;

    CertificateRevoked(_certificateId: BigNumberish | null): EventFilter;

    CertificationRequestApproved(
      _owner: string | null,
      _id: BigNumberish | null,
      _certificateId: BigNumberish | null
    ): EventFilter;

    CertificationRequestRevoked(
      _owner: string | null,
      _id: BigNumberish | null
    ): EventFilter;

    CertificationRequested(
      _owner: string | null,
      _id: BigNumberish | null,
      _deviceId: string | null
    ): EventFilter;

    CommitmentUpdated(
      _owner: string | null,
      _id: BigNumberish | null,
      _commitment: null
    ): EventFilter;

    MigrateToPublicRequested(
      _owner: string | null,
      _id: BigNumberish | null
    ): EventFilter;

    OwnershipTransferred(
      previousOwner: string | null,
      newOwner: string | null
    ): EventFilter;

    PrivateTransferRequested(
      _owner: string | null,
      _certificateId: BigNumberish | null
    ): EventFilter;
  };

  estimate: {
    certificateTopic(): Promise<BigNumber>;

    isOwner(): Promise<BigNumber>;

    owner(): Promise<BigNumber>;

    registry(): Promise<BigNumber>;

    renounceOwnership(): Promise<BigNumber>;

    transferOwnership(newOwner: string): Promise<BigNumber>;

    initialize(
      _certificateTopic: BigNumberish,
      _registry: string,
      _owner: string
    ): Promise<BigNumber>;

    getCertificationRequest(_requestId: BigNumberish): Promise<BigNumber>;

    getCertificateCommitment(certificateId: BigNumberish): Promise<BigNumber>;

    totalRequests(): Promise<BigNumber>;

    requestCertificationFor(
      _data: Arrayish,
      _owner: string,
      _private: boolean
    ): Promise<BigNumber>;

    requestCertification(
      _data: Arrayish,
      _private: boolean
    ): Promise<BigNumber>;

    isRequestValid(_requestId: BigNumberish): Promise<BigNumber>;

    revokeRequest(_requestId: BigNumberish): Promise<BigNumber>;

    revokeCertificate(_certificateId: BigNumberish): Promise<BigNumber>;

    approveCertificationRequest(
      _requestId: BigNumberish,
      _value: BigNumberish,
      _validityData: Arrayish
    ): Promise<BigNumber>;

    issue(
      _to: string,
      _value: BigNumberish,
      _data: Arrayish
    ): Promise<BigNumber>;

    approveCertificationRequestPrivate(
      _requestId: BigNumberish,
      _commitment: Arrayish,
      _validityData: Arrayish
    ): Promise<BigNumber>;

    issuePrivate(
      _to: string,
      _commitment: Arrayish,
      _data: Arrayish
    ): Promise<BigNumber>;

    requestPrivateTransfer(
      _certificateId: BigNumberish,
      _ownerAddressLeafHash: Arrayish
    ): Promise<BigNumber>;

    approvePrivateTransfer(
      _certificateId: BigNumberish,
      _proof: { left: boolean; hash: Arrayish }[],
      _previousCommitment: Arrayish,
      _commitment: Arrayish
    ): Promise<BigNumber>;

    requestMigrateToPublic(
      _certificateId: BigNumberish,
      _ownerAddressLeafHash: Arrayish
    ): Promise<BigNumber>;

    getPrivateTransferRequest(_certificateId: BigNumberish): Promise<BigNumber>;

    getMigrationRequest(_requestId: BigNumberish): Promise<BigNumber>;

    getMigrationRequestId(_certificateId: BigNumberish): Promise<BigNumber>;

    migrateToPublic(
      _requestId: BigNumberish,
      _volume: BigNumberish,
      _salt: string,
      _proof: { left: boolean; hash: Arrayish }[]
    ): Promise<BigNumber>;

    encodeData(
      _from: BigNumberish,
      _to: BigNumberish,
      _deviceId: string
    ): Promise<BigNumber>;

    decodeData(_data: Arrayish): Promise<BigNumber>;

    getRegistryAddress(): Promise<BigNumber>;

    version(): Promise<BigNumber>;
  };
}
